
module ad7606C_ddr3_usb(
    clk,
    reset_n,
    //LED
    led,
    //AD7606
	ad7606_cs_n_o, 
	ad7606_rd_n_o, 
	ad7606_busy_i, 
	ad7606_db_i,   
	ad7606_os_o,   
	ad7606_reset_o,
	ad7606_convst_oA,
	ad7606_convst_oB,
     //DDR3 Interface
    // Inouts
    ddr3_dq,
    ddr3_dqs_n,
    ddr3_dqs_p,
    // Outputs
    ddr3_addr,
    ddr3_ba,
    ddr3_ras_n,
    ddr3_cas_n,
    ddr3_we_n,
    ddr3_reset_n,
    ddr3_ck_p,
    ddr3_ck_n,
    ddr3_cke,
    ddr3_cs_n,
    ddr3_dm,
    ddr3_odt,
//    fx2 fifo clear
    
    fx2_clear,
    fx2_fdata,
    fx2_flagb,
    fx2_flagc,
    fx2_ifclk,
    fx2_faddr,
    fx2_sloe,
    fx2_slwr,
    fx2_slrd,
    fx2_pkt_end,
    fx2_slcs   

    );
    input clk;
    input reset_n;
    
    //LED
    output [1:0]led;  
    //AD7606
    output wire        ad7606_cs_n_o;         
	output wire         ad7606_rd_n_o;         
	input  wire        ad7606_busy_i;         
	input  wire [15:0] ad7606_db_i;           
	output wire [2:0]  ad7606_os_o;           
	output wire         ad7606_reset_o;        
	output wire         ad7606_convst_oA; 
	output wire         ad7606_convst_oB; 
	assign ad7606_convst_oB = ad7606_convst_oA;
    //DDR3 Interface
    // Inouts
    inout  [15:0]ddr3_dq;
    inout  [1:0]ddr3_dqs_n;
    inout  [1:0]ddr3_dqs_p;
    // Outputs
    output [13:0]ddr3_addr;
    output [2:0] ddr3_ba;
    output ddr3_ras_n;
    output ddr3_cas_n;
    output ddr3_we_n;
    output ddr3_reset_n;
    output [0:0]ddr3_ck_p;
    output [0:0]ddr3_ck_n;
    output [0:0]ddr3_cke;
    output [0:0]ddr3_cs_n;
    output [1:0]ddr3_dm;
    output [0:0]ddr3_odt;
    
    output fx2_clear; 
    ////usb_ctrl
    inout [15:0]fx2_fdata;
    input fx2_flagb;
    input fx2_flagc;
    input fx2_ifclk;
    
    output [1:0]fx2_faddr;
    output fx2_sloe;
    output fx2_slwr;
    output fx2_slrd;
    output fx2_pkt_end; 
    output fx2_slcs;

    reg start_sample_r1;
    reg start_sample_r2;
    reg start_sample_r3;
    reg start_sample_r4;
    reg start_sample_r5;
    
    wire [15:0]usb_fifo_wrdata;
    wire usb_fifo_wrreq;
    wire [10:0]usb_fifo_usedw;
    wire clk_100M;  //DDR3ģʱź
    wire clk_200M; //DDR3ʱź
    wire pll_locked; //PLLź
    
    wire ddr3_rst_n;
    wire g_reset;
    
    wire [7:0]cmd_addr;
    wire [31:0]cmd_data;
    wire cmdvalid;
    
    wire start_sample;
    wire [31:0]set_sample_num;
    
    wire [7:0]adc_ch_sel;
//    wire [15:0]ad_out;
//    wire ad_out_valid;
    
    wire ddr3_init_done;
    
    wire wrfifo_clr;
    wire wrfifo_full;
    
    wire ad_sample_en;
    
    wire rdfifo_clr;
    wire rdfifo_empty;
    wire rdfifo_rden;
    wire [15:0]rdfifo_dout;
    
    wire [15:0]usb_data_out;
    wire usb_data_valid;
    wire usb_source_ready;
    
    wire [1:0]fx2_faddr0;//FX2USB2.0оƬSlaveFIFOFIFOַ
    wire fx2_slrd0;//FX2USB2.0оƬSlaveFIFOĶźţ͵ƽЧ
    wire fx2_slwr0;//FX2USB2.0оƬSlaveFIFOдźţ͵ƽЧ
    wire fx2_sloe0;//FX2USB2.0оƬSlaveFIFOʹźţ͵ƽЧ
    wire fx2_flagc0;//FX2USB2.0оƬĶ˵6־
    wire fx2_flagb0; //FX2USB2.0оƬĶ˵2ձ־
    wire fx2_pkt_end0;//ݰ־ź
    wire fx2_slcs0;
    
    wire [15:0]fx2_fdata1;
    wire [1:0]fx2_faddr1;//FX2USB2.0оƬSlaveFIFOFIFOַ
    wire fx2_slrd1;//FX2USB2.0оƬSlaveFIFOĶźţ͵ƽЧ
    wire fx2_slwr1;//FX2USB2.0оƬSlaveFIFOдźţ͵ƽЧ
    wire fx2_sloe1;//FX2USB2.0оƬSlaveFIFOʹźţ͵ƽЧ
    wire fx2_flagc1;//FX2USB2.0оƬĶ˵6־
    wire fx2_flagb1;//FX2USB2.0оƬĶ˵2ձ־
    wire fx2_pkt_end1;//ݰ־ź
    wire fx2_slcs1;
    
    wire inout_switch;    
    //0: readpcFPGA·ָ   1:writeFPGAfx2оƬ̶pcϴ
    wire usb_fifo_wrempty;
    wire rw_switch;
    
    wire [7:0]adc_data_flag;
    wire [15:0]adc_data_mult_ch; 
    
    assign rw_switch = (inout_switch || (usb_fifo_wrempty == 0 ))?1'd1:1'd0;
    //inout_switchΪ1rw_switchΪ1ĳ
    //usb_fifo_wremptyûΪ1
    //˵usbfifoûж꣬ҪٸһʱֱյΪ0ķ
    assign fx2_fdata=rw_switch? fx2_fdata1 : 16'dz;
    
    assign fx2_faddr=rw_switch ? fx2_faddr1 : fx2_faddr0;
    assign fx2_sloe=rw_switch ? fx2_sloe1 : fx2_sloe0;
    assign fx2_slwr=rw_switch ? fx2_slwr1 : fx2_slwr0;
    assign fx2_slrd=rw_switch ? fx2_slrd1 : fx2_slrd0;
    assign fx2_pkt_end=rw_switch ? fx2_pkt_end1 : fx2_pkt_end0;
    assign fx2_slcs=rw_switch ? fx2_slcs1 : fx2_slcs0;
  
    assign ddr3_rst_n = pll_locked;
    assign g_reset = ~pll_locked;
    
    //led[0] ໷źΪߣ˵໷ʱ
    //led[1] DDR3ʼɱʶźţΪߣ˵DDR3Ѿɳʼ
    assign led = {ddr3_init_done,pll_locked};

    
    //PLLģ飺ڲģĹʱ
    pll pll
    (
    // Clock out ports
    .clk_out1(clk_100M),     // output clk_out1
    .clk_out2(clk_200M),     // output clk_out2
    // Status and control signals
    .resetn(reset_n), // input resetn
    .locked(pll_locked),       // output locked
    .clk_in1(clk));      // input clk_in1
    
    //USBͿģ飺ϵĽ˵2еݶȡݶȡֱΪ˿
    usb_stream_out usb_stream_out(
        .clk (clk_100M),
        .fx2_fdata (fx2_fdata), //  FX2USB2.0оƬSlaveFIFO
        .fx2_faddr (fx2_faddr0), //  FX2USB2.0оƬSlaveFIFOFIFOַ
        .fx2_slrd (fx2_slrd0),  //  FX2USB2.0оƬSlaveFIFOĶźţ͵ƽЧ
        .fx2_slwr (fx2_slwr0),  //  FX2USB2.0оƬSlaveFIFOдźţ͵ƽЧ
        .fx2_sloe (fx2_sloe0),  //  FX2USB2.0оƬSlaveFIFOʹźţ͵ƽЧ
        .fx2_flagc (fx2_flagc ), //  FX2USB2.0оƬĶ˵6־
        .fx2_flagb (fx2_flagb ), //  FX2USB2.0оƬĶ˵2ձ־
        .fx2_ifclk (fx2_ifclk ), //  FX2USB2.0оƬĽӿʱź
        .fx2_pkt_end (fx2_pkt_end0),	//ݰ־ź
        .fx2_slcs (fx2_slcs0),
        .reset_n (reset_n),
        
        .data_out (usb_data_out),	
        //FPGA˵USB.ݴpcfx2оƬṩFPGA
        
        .data_valid (usb_data_valid),	
        //FPGA˵USBЧ־ź.FPGAֻҪڶݣźһֱFX2
        
        .source_ready (~rw_switch)	
        //ⲿݽźţFPGAеĻFIFO㹻Ŀռ洢һ֡USBݣSlave FIFOȥȡݡFPGAȡһ֡ݣ
    );
    ////////////·ģԽյźŽнַݡЧȻַͨжǲʼźţǲͨ////////////
    usb_cmd usb_cmd_inst(
        .Clk (fx2_ifclk),
        .Reset_n (~g_reset),
        .rx_data (usb_data_out),
        .rx_done (usb_data_valid),
        .address (cmd_addr),
        .data (cmd_data),
        .cmdvalid (cmdvalid)
    );

    wire[31:0]set_sample_speed; 
    usb_cmd_rx usb_cmd_rx(
        .clk (fx2_ifclk),
        .reset (g_reset),
        .adc_ch_sel (adc_ch_sel),
        .set_sample_num (set_sample_num),
        .set_sample_speed(set_sample_speed),   
        .start_sample (start_sample),
        .cmdvalid (cmdvalid),
        .cmd_addr (cmd_addr),
        .cmd_data (cmd_data)
    );
    
    always@(posedge clk_100M)
    begin
        start_sample_r1<=start_sample;
        start_sample_r2<=start_sample_r1;
        start_sample_r3<=start_sample_r2;
        start_sample_r4<=start_sample_r3;
        start_sample_r5<=start_sample_r4;
    end  
    
    
     //AD7606ģ
    ad7606C_driver ad7606C_driver(
        .Clk(clk_100M),
        .Reset_n(~g_reset),
        .Go(1),
        .Speed_Set(set_sample_speed),
        .Conv_Done(),
        .ad7606_cs_n_o(ad7606_cs_n_o), 
        .ad7606_rd_n_o(ad7606_rd_n_o), 
        .ad7606_busy_i(ad7606_busy_i), 
        .ad7606_db_i(ad7606_db_i), 
        .ad7606_os_o(ad7606_os_o), 
        .ad7606_reset_o(ad7606_reset_o), 
        .ad7606_convst_o(ad7606_convst_oA), 
		.data_flag(adc_data_flag),
		.data_mult_ch(adc_data_mult_ch),
        .data1(),
        .data2(), 
        .data3(), 
        .data4(), 
        .data5(), 
        .data6(), 
        .data7(), 
        .data8()
    );
    
  state_ctrl state_ctrl(
    .clk (clk_100M),
    .reset (g_reset),
    .fx2_clear (fx2_clear),
    .inout_switch (inout_switch),

    .ddr3_init_done (ddr3_init_done),

    .start_sample (start_sample_r5),
    .set_sample_num (set_sample_num),
    .adc_ch_sel(adc_ch_sel),
    .adc_data_flag(adc_data_flag),
    
    .rdfifo_empty (rdfifo_empty),
    .rdfifo_clr (rdfifo_clr),
    .rdfifo_rden (rdfifo_rden),
    .rdfifo_dout (rdfifo_dout),

    .wrfifo_full (wrfifo_full),
    .wrfifo_clr (wrfifo_clr),
    .ad_sample_en (ad_sample_en),
//    .adc_data_en    (adc_data_en   ),

    .usb_fifo_wrreq (usb_fifo_wrreq),
    .usb_fifo_wrdata (usb_fifo_wrdata),
    .usb_fifo_usedw (usb_fifo_usedw )
  );
    
        
    //DDR3˫˿ģ
    ddr3_ctrl_2port #(
    .DW            (16),
    .WR_ADDR_BEGIN (0),//洢дʼλ
    .WR_ADDR_END   (128*1024*1024-1),//洢дֹλ
    .RD_ADDR_BEGIN (0),//洢Ķʼλ
    .RD_ADDR_END   (128*1024*1024-1)//洢Ķֹλ
  )
  ddr3_ctrl_2port(
    .ddr3_clk200m  (clk_200M   ),
    .ddr3_rst_n    (ddr3_rst_n    ),
    .ddr3_init_done(ddr3_init_done),
    .wrfifo_clr    (wrfifo_clr    ),
    .wrfifo_clk    (clk_100M    ),
    .wrfifo_wren   ((adc_data_flag & adc_ch_sel)  && ad_sample_en),
    .wrfifo_din    (adc_data_mult_ch),
    .wrfifo_full   (wrfifo_full   ),
    .wrfifo_wr_cnt (              ),
    //rd_fifo Interface
    .rdfifo_clr    (rdfifo_clr    ),
    .rdfifo_clk    (clk_100M    ),
    .rdfifo_rden   (rdfifo_rden   ),
    .rdfifo_dout   (rdfifo_dout   ),
    .rdfifo_empty  (rdfifo_empty  ),
    .rdfifo_rd_cnt (              ),
    // Inouts
    .ddr3_dq       (ddr3_dq       ),
    .ddr3_dqs_n    (ddr3_dqs_n    ),
    .ddr3_dqs_p    (ddr3_dqs_p    ),
    // Outputs      
    .ddr3_addr     (ddr3_addr     ),
    .ddr3_ba       (ddr3_ba       ),
    .ddr3_ras_n    (ddr3_ras_n    ),
    .ddr3_cas_n    (ddr3_cas_n    ),
    .ddr3_we_n     (ddr3_we_n     ),
    .ddr3_reset_n  (ddr3_reset_n  ),
    .ddr3_ck_p     (ddr3_ck_p     ),
    .ddr3_ck_n     (ddr3_ck_n     ),
    .ddr3_cke      (ddr3_cke      ),
    .ddr3_cs_n     (ddr3_cs_n     ),
    .ddr3_dm       (ddr3_dm       ),
    .ddr3_odt      (ddr3_odt      )
   );
    
      //USBͿģ
  usb_stream_in usb_stream_in(
    .fifo_rst(start_sample||start_sample_r1||start_sample_r2||start_sample_r3||start_sample_r4||start_sample_r5),
    .reset_n (ddr3_init_done),
    .fx2_fdata (fx2_fdata1), //FX2USB2.0оƬSlaveFIFO
    .fx2_faddr (fx2_faddr1), //FX2USB2.0оƬSlaveFIFOFIFOַ
    .fx2_slrd (fx2_slrd1), //FX2USB2.0оƬSlaveFIFOĶźţ͵ƽЧ
    .fx2_slwr (fx2_slwr1), //FX2USB2.0оƬSlaveFIFOдźţ͵ƽЧ
    .fx2_sloe (fx2_sloe1), //FX2USB2.0оƬSlaveFIFOʹźţ͵ƽЧ
    .fx2_flagc (fx2_flagc), //FX2USB2.0оƬĶ˵6־
    .fx2_flagb (fx2_flagb), //FX2USB2.0оƬĶ˵2ձ־
    .fx2_ifclk (fx2_ifclk), //FX2USB2.0оƬĽӿʱź
    .fx2_pkt_end (fx2_pkt_end1), //ݰ־ź
    .fx2_slcs (fx2_slcs1),

    .usb_fifo_wrclk (clk_100M),
    .usb_fifo_wrdata(usb_fifo_wrdata),
    .usb_fifo_wrreq (usb_fifo_wrreq),
    .usb_fifo_usedw (usb_fifo_usedw),
    .usb_fifo_wrempty(usb_fifo_wrempty)
  );
endmodule
    
