`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/09/28 20:00:18
// Design Name: 
// Module Name: usb_stream_out
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module usb_stream_out(
    clk,
    fx2_fdata, //  FX2USB2.0оƬSlaveFIFO
    fx2_faddr, //  FX2USB2.0оƬSlaveFIFOFIFOַ
    fx2_slrd,  //  FX2USB2.0оƬSlaveFIFOĶźţ͵ƽЧ
    fx2_slwr,  //  FX2USB2.0оƬSlaveFIFOдźţ͵ƽЧ
    fx2_sloe,  //  FX2USB2.0оƬSlaveFIFOʹźţ͵ƽЧ
    fx2_flagc, //  FX2USB2.0оƬĶ˵6־
    fx2_flagb, //  FX2USB2.0оƬĶ˵2ձ־
    fx2_ifclk, //  FX2USB2.0оƬĽӿʱź
    fx2_pkt_end,	//ݰ־ź
    fx2_slcs,
    reset_n,
    data_out,	//FPGA˵USB
    data_valid,	//FPGA˵USBЧ־ź
    source_ready	//ⲿݽźţFPGAеĻFIFO㹻Ŀռ洢һ֡USBݣSlave FIFOȥȡݡ
    );
    input clk;
    input reset_n;
    input [15:0]fx2_fdata;
    input fx2_flagb;
    input fx2_flagc;
    input fx2_ifclk;
    
    output [1:0]fx2_faddr;
    output fx2_sloe;
    output fx2_slwr;
    output fx2_slrd;
    output fx2_pkt_end;
    output fx2_slcs;
        
    output reg [15:0] data_out;
    output reg data_valid;
    
    input source_ready;
    
    reg slrd_n;
    reg slwr_n;
    reg sloe_n;
    
    reg [1:0]faddr_n;
    
    parameter [1:0] stream_out_idle       = 2'd0;
    parameter [1:0] stream_out_read       = 2'd1;
    parameter [1:0] stream_out_wait       = 2'd2;
    
    reg [1:0]current_stream_out_state;
    reg [1:0]next_stream_out_state;
    
    assign fx2_slwr = 1;
    assign fx2_slrd = slrd_n;
    assign fx2_sloe = sloe_n;
    assign fx2_faddr = 2'b00;
    assign fx2_pkt_end = 1'b1;
    assign fx2_slcs = 1'b0;
    
    //USB߼
    always@(posedge fx2_ifclk)begin
    data_out <= fx2_fdata;
    data_valid <= ~slrd_n;
    end
    
    
    //Slave FIFOź
    always@(*)begin
    if((current_stream_out_state == stream_out_read) & (fx2_flagb == 1'b1))begin
        slrd_n = 1'b0;
        sloe_n = 1'b0;
    end 
    else begin
      slrd_n = 1'b1;
      sloe_n = 1'b1;
    end
    end	
    
    //ʽ״̬̬ʹ̬л
    always@(posedge fx2_ifclk, negedge reset_n) begin
    if(reset_n == 1'b0)
      current_stream_out_state <= stream_out_wait;
    else
      current_stream_out_state <= next_stream_out_state;
    end
    
    //ʽ״̬״̬ת
    always@(*) begin
    next_stream_out_state = current_stream_out_state;
    case(current_stream_out_state)
      stream_out_wait:begin	//ȴʹ߼USBжȡµ
      if(source_ready)
        next_stream_out_state = stream_out_idle;
      else
         next_stream_out_state = stream_out_wait;
      end
      
      stream_out_idle:begin	//ȴFX2Slave FIFOж˵2ǿ
      if(fx2_flagb == 1'b1)
        next_stream_out_state = stream_out_read;
      else
        next_stream_out_state = stream_out_idle;
      end
      
      stream_out_read:begin	//Ӷ˵2жȡ
      if(fx2_flagb == 1'b0)
         next_stream_out_state = stream_out_wait;
      else
         next_stream_out_state = stream_out_read;
      end
      
      default: 
         next_stream_out_state = stream_out_wait;
    endcase		
    end
endmodule
